#ifndef __PARAM_SELECTOR__
#define __PARAM_SELECTOR__

#include <gtk/gtk.h>
#include "patch.h"

G_BEGIN_DECLS

#define PARAM_SELECTOR_TYPE (param_selector_get_type())
#define PARAM_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PARAM_SELECTOR_TYPE, ParamSelector))
#define PARAM_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PARAM_SELECTOR_TYPE, ParamSelectorClass))
#define IS_PARAM_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PARAM_SELECTOR_TYPE))
#define IS_PARAM_SELECTOR_CLASS(klass) (G_TYPE_CHECK_INSTANCE_TYPE ((klass), PARAM_SELECTOR_TYPE))

typedef struct _ParamSelectorClass ParamSelectorClass;
typedef struct _ParamSelector ParamSelector;

struct _ParamSelector
{
    GtkHBox parent;

    /*< private >*/
    GtkWidget* current;
    GtkWidget* vol;
    GtkWidget* pan;
    GtkWidget* cut;
    GtkWidget* res;
    GtkWidget* pitch;
};

struct _ParamSelectorClass
{
    GtkHBoxClass parent_class;

    /*< private >*/
    void (*changed)(ParamSelector* self);
};

GType param_selector_get_type(void);
GtkWidget* param_selector_new(void);
PatchParamType param_selector_get(ParamSelector* self);

G_END_DECLS

#endif /* __PARAM_SELECTOR__ */
